;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
; Toby Opferman                                    ;
;   WinPong32                                      ;
;                                                  ;
;  Windows Pong Written for WIN32 in Assembly      ;
;  Source Code Copyright 1998                      ;
;                                                  ;  
; http://www.opferman.com                          ;
; _Secret/Scrat                                    ;
; programming@opferman.com                         ;    
;                                                  ;    
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
;    D I S C L A I M E R  AND  L I S E N C E       ;
;                                                  ;    
;   I lisence out this code my first Win32 program ;
;  written in Assembly for educational use only.   ;
;  There are no warrenties implied or here in.     ;
;  Use at your own risk.  I am not responsible for ; 
;  any catastropic ressults occuring from use or   ;
;  replication of this code in any way or form.    ;
;  Free to use code as a reference or educational  ;
;  tool only.  If you use any of the subroutines   ;
;  give credit where credit is due.  No using      ;
;  any part of this code to make commerical        ;
;  products unless notifing the author for         ;
;  permission.                                     ;
;                                                  ;    
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=; 


; Processor & Model
.486
.MODEL FLAT, STDCALL

; Include File
INCLUDE WIN32.INC

;  WIN32.INC is the exmaple file from TASM 5.0.  You will
;   need to add Function prototypes and variable definitions
;   in order to compile this program since it has a limited
;   amount of information.


; Export Function (Windows Call Back)
PUBLIC WndProc

;-=-=-=-=-=-=-=-=-=-=-
; Define the Data
;-=-=-=-=-=-=-=-=-=-=-
.DATA

; Window Handle, and Window Structures
 HWND       dd 0       
 PS         PAINTSTRUCT <?>
 MSG        MSGSTRUCT   <?>
 WC         WNDCLASS    <?>
 trect      RECT <?>
 hInst      dd 0

; Title & Class 
 Title1     db 'Windows Pong 32 bit v1.0 Alpha', 0  
 ClassName  db 'WINPONG32', 0

; Arrow Key Press/Release Identifires
 LeftArrow  db 0
 RightArrow db 0

; Random Seeds
 Seed1     dd ?
 Seed2     dd ?
 Seed3     dd ?
 Seed4     dd ?  

; X & Y Position of Ball and Paddle
 PongX      dd 0
 PongY      dd 0
 PaddleX    dd 0
 PaddleY    dd 0

; Game On/Off Identifier
 GameOn     db 0

; The Score
 Score      dd 0

; Screen Resolution
 MaxX       dd ?
 MaxY       dd ?

; Score Screen Text
 ScoreTxt  db 'Score = '
 ExtraBytes db '                     '

; Velocity of the Ball
 VelX       dd 0
 VelY       dd 0

; Handle to Bitmap Temporary Storage 
 Temp       HBITMAP  ?
 
; Handle to Device Contexts
 DoubleBuffer  HDC   ?
 whdc          HDC   ?
 BallDC        HDC   ?
 PaddleDC      HDC   ?
 
;  
 MenuText   db 'PongMenu', 0
 AboutText  db 'AboutBox', 0

; Menu Options
 IDM_PLAY   equ <1>
 IDM_QUIT   equ <2>
 IDM_ABOUT  equ <3>

; Icons and Bitmaps from Resource Script
 PongIcon   equ 101
 PaddleGFX  equ 200
 BallGFX    equ 201


;-=-=-=-=-=-=-=-=-=-=-=-
; The Code
;-=-=-=-=-=-=-=-=-=-=-=-
.CODE

;  Execution Starts Here (WinMain)

START:

 PUSH L 0
 CALL GetModuleHandle                   ; Get the hInstance of the window
 MOV [hInst], EAX

 MOV [WC.clsHInstance], EAX             ; Populate the Windows Class Structure  
 MOV [WC.clsStyle], 0
 MOV [WC.clsLpfnWndProc], OFFSET WndProc
 MOV [WC.clsCbClsExtra], 0
 MOV [WC.clsCbWndExtra], 0

 PUSH L PongIcon                        ; Load The Icon
 PUSH EAX
 CALL LoadIcon

 MOV [WC.clsHIcon], EAX
 MOV [WC.hIconSm], EAX

 PUSH L IDC_ARROW                       ; Load Cursor
 PUSH L 0 
 CALL LoadCursor

 MOV [WC.clsHCursor], EAX

 PUSH L BLACK_BRUSH
 CALL GetStockObject                    ; Black Background

 MOV [WC.clsHbrBackground], EAX
 MOV [WC.clsLpszMenuName], OFFSET MenuText
 MOV [WC.clsLpszClassName], OFFSET ClassName
 

 PUSH L SM_CYSCREEN                     ; Get Screen Y Resolution
 CALL GetSystemMetrics
 MOV [MaxY], EAX
 
 PUSH L SM_CXSCREEN
 CALL GetSystemMetrics                  ; Get Screen X Resolution
 MOV [MaxX], EAX
 
 PUSH OFFSET WC
 CALL RegisterClass                     ; Register the Window
 
 
 PUSH L 0
 PUSH [hInst]
 PUSH L 0
 PUSH L 0
 PUSH  [MaxY]
 PUSH  [MaxX]
 PUSH L CW_USEDEFAULT
 PUSH L CW_USEDEFAULT
 PUSH L WS_OVERLAPPED + WS_CAPTION + WS_SYSMENU + WS_MAXIMIZE + WS_BORDER
 PUSH OFFSET Title1
 PUSH OFFSET ClassName
 PUSH L 0
 CALL CreateWindowEx                    ; Create The Window
 MOV [HWND], EAX

 PUSH L SW_SHOWNORMAL
 PUSH [HWND] 
 CALL ShowWindow                        ; Show And Update The Window
 
 PUSH [HWND]
 CALL UpdateWindow
 
 
 MessageLoop:                           ; Main Message Loop
   PUSH L 0
   PUSH L 0
   PUSH L 0
   PUSH OFFSET MSG
   CALL GetMessage
 
   TEST EAX, EAX                        ; When GetMessage Returns a 0, Window Destoryed
   JZ SHORT QUIT
   
   PUSH OFFSET MSG
   CALL TranslateMessage        
   
   PUSH OFFSET MSG
   CALL DispatchMessage
 
 JMP SHORT MessageLoop
 
 QUIT:
 
 PUSH [MSG.msWPARAM]                    ; Exit Program
 CALL ExitProcess
 ; End Of Program

;-=-=-=-=-=-=-=-=-=-=-=-=-=-
; Windows Call Back Function
;-=-=-=-=-=-=-=-=-=-=-=-=-=-
WndProc PROC USES EBX EDI ESI, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD

  MOV EAX, wmsg                 ; Check Windows Messages
  
  CMP EAX, WM_CREATE            ; Create
  JE  WCREATE

  CMP EAX, WM_PAINT             ; Paint
  JE  WPAINT
  
  CMP EAX, WM_TIMER             ; Timer
  JE  WTIMER

  CMP EAX, WM_KEYDOWN           ; Key Down
  JE  WKEYDOWN

  CMP EAX, WM_KEYUP             ; Key Up
  JE  WKEYUP
  
  CMP EAX, WM_MOUSEMOVE         ; Mouse Movement
  JE  WMOUSEMOVE
    
  CMP EAX, WM_COMMAND           ; Menu Command
  JE WCOMMAND

  CMP EAX, WM_DESTROY           ; Destroy Window
  JE WDESTROY
  
  PUSH [lparam]
  PUSH [wparam]
  PUSH [wmsg]
  PUSH [hwnd]
  CALL DefWindowProc            ; Default exit, let windows process message.
  RET
  
  WCREATE:
    CALL Seed                   ; Seed Random Number Generator

    PUSH L 0
    CALL CreateCompatibleDC     ; Create Double Buffer
    MOV [DoubleBuffer], EAX

    PUSH [hwnd]
    CALL GetDC
    
    MOV EBX, [MaxY]
    SUB EBX, 40
    PUSH EBX
    PUSH [MaxX]
    PUSH EAX                    ; Create BitMap of the Screen
    CALL CreateCompatibleBitmap
    
    PUSH EAX
    PUSH [DoubleBuffer]
    CALL SelectObject           ; Set Double Buffer to it
    
    PUSH L TRANSPARENT
    PUSH [DoubleBuffer]
    CALL SetBkMode              ; Set Text Mode as Transparent White
    
    PUSH L 0FFFFFFh
    PUSH [DoubleBuffer]
    CALL SetTextColor


    PUSH L PaddleGFX            ; Load The Paddle Graphics
    PUSH [hInst]
    CALL LoadBitmap   
    
    MOV [Temp], EAX
	
    PUSH L 0
    CALL CreateCompatibleDC
    
    MOV [PaddleDC], EAX
    PUSH [Temp]
    PUSH EAX
    CALL SelectObject

    PUSH L BallGFX              ; Load The Ball Graphics
    PUSH [hInst]
    CALL LoadBitmap
       
    MOV [Temp], EAX
    PUSH L 0
    CALL CreateCompatibleDC
    
    MOV [BallDC], EAX
    PUSH [Temp]
    PUSH EAX
    CALL SelectObject
    
    
    
    PUSH L 0
    PUSH OFFSET AboutProc 
    PUSH [hwnd]
    PUSH OFFSET AboutText
    PUSH [hInst]
    CALL DialogBoxParam         ; Call About Box 
    XOR EAX, EAX 
    RET
    
  WPAINT:
      PUSH OFFSET PS
      PUSH [hwnd]
      CALL BeginPaint           ; Begin Windows Paint
      
      MOV [whdc], EAX

      PUSH OFFSET trect
      PUSH [hwnd]
      CALL GetClientRect
      
      CMP [GameOn], 1           ; If Game Playing??
      JNE SHORT NoGame

       MOV EAX, [MaxY]          ; If yes, Then Put Game Screen To Window
       SUB EAX, 41
       PUSH L SRCCOPY
       PUSH EAX

       MOV EAX, [MaxX]
       DEC EAX
       PUSH  EAX 
       PUSH L 0
       PUSH L 0
       PUSH [DoubleBuffer]

       MOV EAX, [MaxY]
       SUB EAX, 41
       PUSH EAX

       MOV EAX, [MaxX]
       DEC EAX
       PUSH EAX

       PUSH L 0
       PUSH L 0
       PUSH [whdc]
       CALL StretchBlt


      JMP SHORT FINISH          ; End Paint

      NoGame:

       PUSH L TRANSPARENT       ; No Game In Play, So Set Text to White transparent
       PUSH [whdc]
       CALL SetBkMode
    
       PUSH L 0FFFFFFh
       PUSH [whdc]
       CALL SetTextColor
       
       ; Score Here. Transparent
       MOV EDX, [Score]
       MOV EDI, OFFSET  ExtraBytes   ; Convert Doubleword to Ascii String
       CALL NUMBA 
       
       
       MOV EAX, [MaxY]
       SUB EAX, 41
	   
       PUSH EAX
       MOV EAX, [MaxX]
       DEC EAX
       
       PUSH EAX
       PUSH L 0
       PUSH L 0 
       PUSH OFFSET trect                ; Paint Whole Screen Black
       CALL SetRect

       PUSH L BLACK_BRUSH
       CALL GetStockObject
       PUSH EAX
       PUSH OFFSET trect
       PUSH [whdc]
       CALL FillRect
       
       PUSH L 29 
       PUSH OFFSET ScoreTxt
       PUSH L 10
       PUSH L 10                        ; Write Score on Screen
       PUSH [whdc]
       CALL TextOut
     

  FINISH:
      
    PUSH OFFSET PS
    PUSH [hwnd]
    CALL EndPaint                        ; End Paint & Exit
      
    XOR EAX, EAX
    RET

  WTIMER:                                ; Timer Message
    MOV EAX, [MaxY]
    SUB EAX, 41
    PUSH EAX

    MOV EAX, [MaxX]                      ; Set Screen To Be Painted Black       
    DEC EAX
    PUSH EAX

    PUSH L 0
    PUSH L 0 
    PUSH OFFSET trect
    CALL SetRect


    PUSH L BLACK_BRUSH
    CALL GetStockObject                  ; Get Black Brush

    PUSH EAX
    PUSH OFFSET trect
    PUSH [DoubleBuffer]
    CALL FillRect                        ; Fill Game Screen Black
    
    CMP [RightArrow], 1                  ; Keyboard Check.  Right Arrow Pressed?
    JE  MOVE_RIGHT
    
    CMP [LeftArrow], 1                   ; Left Arrow Pressed?
    JE  MOVE_LEFT
    
NEXT:    


    MOV EAX, [VelX]                      ; Move the Ball
    ADD [PongX], EAX
    
    MOV EAX, [VelY]
    ADD [PongY], EAX
    

    MOV EAX, [PongX]                     ; Check Paddle Left Side with Ball Right Side
    ADD EAX, 26

    CMP EAX, [PaddleX]                   ; If Right Side of ball not in Paddle
    JL SHORT NOHIT                       ; X Scope, Then NO Hit
    
    MOV EAX, [PaddleX]                   ; Check Paddle Right Side with Ball Left Side
    ADD EAX, 57

    CMP [PongX], EAX                     ; If Left Side of ball not in Paddle 
    JG SHORT NOHIT                       ; X Scope, Then NO Hit
    
    MOV EAX, [PongY]                     ; Check Y Scope
    ADD EAX, 23

    CMP EAX, [PaddleY]                   ; Bottom of Ball not Lower than Top Of Paddle?
    JL SHORT NOHIT                       ; If No, Then No Hit

    MOV EAX, [PaddleY]                   ; Yes, Set Ball To Sit on Top of Paddle
    SUB EAX, 23
    MOV [PongY], EAX
    
    MOV EAX, [VelY]                      ; Score is Velocity of Y for the Ball.
    ADD [Score], EAX                     ; Every paddle hit add it to score
    
    CALL YWALL                           ; Adjust Hit For Y Wall.
       
 NOHIT:
					 ; Check Pong With Wall Hits
    CMP [PongX], 0                       ; Left Wall Hit?
    JG SHORT N
    
    MOV [PongX], 0                       ; Hit Left Wall, Adjust Ball 
    CALL XWALL                           ; Create Bounce
    
    N:
    MOV EAX, [MaxX]                      ; Check Right Wall
    SUB EAX, 26

    CMP [PongX], EAX                     ; Hit Right Wall?
    JL SHORT CheckTopBottom
    
    MOV [PongX], EAX                     ; Hit Right Wall, Adjust Ball
    CALL XWALL   
    
  CheckTopBottom:
    CMP [PongY], 0                       ; Did Ball Hit Top?
    JG SHORT N2
    
    MOV [PongY], 0                       ; Yes, Adjust Ball
    
    CALL YWALL
    
   N2:
    MOV EAX, [MaxY]                     
    SUB EAX, 41 + 28                     ; Ball Hit Bottom Screen?

    CMP [PongY], EAX
    JL PLOT
					 ; Yes, Game Over
    PUSH [WC.clsHCursor]
    CALL SetCursor                       ; Display Mouse Cursor

    CALL ReleaseCapture                  ; Release Mouse Input Capture 

    MOV [GameOn], 0                      ; Set Game Off

    PUSH L 1                             ; End Timer
    PUSH [hwnd]
    CALL KillTimer
	
    
    JMP PLOT                             ; Jump To Plot
    
    MOVE_RIGHT:                          ; Keyboard Move Paddle Right
     ADD [PaddleX], 15
     
     MOV EAX, [MaxX]                     ; Boundry Check
     SUB EAX, 58     
     CMP [PaddleX], EAX
     JL  NEXT
     
     MOV [PaddleX], EAX                  ; Adjust

     JMP NEXT
     
    MOVE_LEFT:
     SUB [PaddleX], 15                   ; Boundry Check

     CMP [PaddleX], 0
     JG  NEXT
     
     MOV [PaddleX], 0                     ; Adjust
     JMP NEXT

    
    
  PLOT:

    PUSH L SRCCOPY
    PUSH L 0
    PUSH L 0
    PUSH [PaddleDC]
    PUSH L 17
    PUSH L 56
    PUSH [PaddleY]
    PUSH [PaddleX]
    PUSH [DoubleBuffer]
    CALL BitBlt                           ; Put Paddle on Screen
    
    PUSH L SRCCOPY
    PUSH L 0
    PUSH L 0
    PUSH [BallDC]
    PUSH L 22
    PUSH L 25
    PUSH [PongY]
    PUSH [PongX]
    PUSH [DoubleBuffer]
    CALL BitBlt                           ; Put Ball on Screen
    
    
    
    MOV EDX, [Score]
    MOV EDI, OFFSET ExtraBytes
    CALL NUMBA                            ; Convert Score to String
    
    
    PUSH L 29 
    PUSH OFFSET ScoreTxt
    PUSH L 10
    PUSH L 10
    PUSH [DoubleBuffer]
    CALL TextOut                          ; Display Score on Screen
    
    
    PUSH OFFSET trect
    PUSH [hwnd]
    CALL GetClientRect                  

    PUSH L FALSE
    PUSH OFFSET trect
    PUSH [hwnd]    
    CALL InvalidateRect                   ; Invalidate Main Window, Invoke a WM_PAINT

    XOR EAX, EAX
    RET

  WKEYDOWN:                               ; KeyPress

    MOV EAX, wparam
    
    CMP EAX, VK_RIGHT                     ; Right Arrow?
    JE SHORT RIGHTD
    
    CMP EAX, VK_LEFT                      ; Left Arrow?
    JE SHORT LEFTD
    
    XOR EAX, EAX
    RET
    
    RIGHTD:
      MOV [RightArrow], 1                 ; Set Right Arrow On
      XOR EAX, EAX
      RET

    LEFTD:
      MOV [LeftArrow], 1                  ; Set Left Arrow On
      XOR EAX, EAX
      RET
    
    
  WKEYUP:

    MOV EAX, wparam                       ; KeyDePress
    
    CMP EAX, VK_RIGHT                     ; Right Arrow?
    JE  RIGHTU
    
    CMP EAX, VK_LEFT                      ; Left Arrow?
    JE  LEFTU
    
    XOR EAX, EAX
    RET

    RIGHTU:
      MOV [RightArrow], 0                 ; Set Right Arrow Off
      XOR EAX, EAX
      RET

    LEFTU:
      MOV [LeftArrow], 0                  ; Set Left Arrow Off
      XOR EAX, EAX
      RET
      
  WMOUSEMOVE:                            ; Mouse Moved
    
    MOV EAX, lparam
    AND EAX, 0FFFFh
    MOVSX EAX, AX
    MOV [PaddleX], EAX                    ; Set X Position of Paddle


    CMP [PaddleX], 0                      ; Check Boundries
    JG  SHORT RCHECK
     
    MOV [PaddleX], 0                      ; Adjust Left
    JMP SHORT DONE3

RCHECK:    
     MOV EAX, [MaxX]                      ; Check Boundries
     SUB EAX, 58
     
     CMP [PaddleX], EAX
     JL  SHORT DONE3
     
     MOV [PaddleX], EAX                   ; Adjust Right
     JMP SHORT DONE3
     


     
    DONE3:
    XOR EAX, EAX                          ; Exit
    RET

  WCOMMAND:                               ; Menu Command

    MOV EAX, wparam
    
    CMP AX, IDM_PLAY                      ; Play Menu Option?
    JE SHORT IPLAY
    
    CMP AX, IDM_QUIT                      ; Quit Menu Option?
    JE  IQUIT
    
    CMP AX, IDM_ABOUT                     ; About Menu Option?
    JE  IABOUT
	
    XOR EAX, EAX                          ; Exit
    RET
    
    IPLAY:
      
      PUSH L 0
      CALL SetCursor                       ; Hide Mouse Cursor

      PUSH [hwnd]
      CALL SetCapture                      ; Capture All Mouse Input
 
      MOV [Score], 0
      MOV [GameOn], 1                      ; Set Game On, Adjust Score

      MOV EAX, [MaxX]
      SHR EAX, 1
      SUB EAX, 12
      MOV [PongX], EAX                     ; Set Ball X Start Position

      SUB EAX, 25-12
      MOV [PaddleX], EAX                   ; Set Paddle X Start Position

      MOV EAX, [MaxY]
      SUB EAX, 80
      MOV [PaddleY], EAX                   ; Set Paddle Y Start Position

      MOV EAX, [MaxY]
      SHR EAX, 1
      MOV [PongY], EAX                     ; Set Ball Y Start Position

      MOV [VelX], 0
      MOV [VelY], 8                        ; Set Start Velocity of Ball
 
 
      PUSH L 0
      PUSH L 33
      PUSH L 1
      PUSH [hwnd]
      CALL SetTimer                        ; Create Game Timer

      XOR EAX, EAX
      RET
    
    IQUIT:
    
      PUSH L 0
      CALL PostQuitMessage                  ; Send Quit Message

      XOR EAX, EAX
      RET
    
    IABOUT:

      PUSH L 0
      PUSH OFFSET AboutProc 
      PUSH [hwnd]
      PUSH OFFSET AboutText
      PUSH [hInst]
      CALL DialogBoxParam                    ; Display About Dialog
    
      XOR EAX, EAX
      RET
    
    
    
  WDESTROY:

    PUSH L 0
    CALL PostQuitMessage                      ; Send Quit Message

    XOR EAX, EAX
    RET
ENDP


;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; Dialog Box Procedure
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
AboutProc PROC hDlg:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
 MOV EAX, wmsg
 
 CMP EAX, WM_COMMAND            ; Command Issued?
 JE SHORT WCOMMAND2
 
 MOV EAX, FALSE                 ; No, Then Exit
 RET
 

 WCOMMAND2:
    MOV EAX, wparam             ; Check Command

    CMP AX, IDOK                ; OK Pressed?
    JE SHORT Process

    CMP AX, IDCANCEL            ; Cancel Pressed?
    JNE SHORT Done

   Process:
    PUSH L 0
    PUSH [hDlg]
    Call EndDialog              ; Close Dialog
   Done:
    
   MOV EAX, TRUE                ; Return TRUE
   RET 

ENDP



;-=-=-=-=-
; Do the Y Wall
;-=-=-=-=-
YWALL PROC
 NEG [VelY]                     ; Hit Y Wall, so go Opposite Direction

 CALL RAND                      ; Get Random Speed for Y Velocity 
 AND EAX, 1Fh                   ; Only Want 0-31
 OR  EAX, 8                     ; Get A Number 8 - 31

 TEST [VelX], 80000000h         ; Is Velocity X Negative?
 JNZ short THENEG
 MOV [VelX], EAX                ; If No, Then Move New Number
 RET

THENEG:
 MOV [VelX], EAX                ; If Yes, Then Move New Number
 NEG [VelX]                     ; And Negate
 RET
ENDP

;-=-=-=-
; Do the X Wall
;-=-=-=-
XWALL PROC
 NEG [VelX]                     ; Hit X Wall, so go Opposite Direction

 Call RAND                      ; Get Random Speed for Y Velocity
 AND EAX, 1Fh                   ; only want 0-31
 OR  EAX, 8                     ; Get a Number 8-31

 TEST [VelY], 80000000h         ; Is Velocity Y Negative?
 JNZ short THENEG2
 MOV [VelY], EAX                ; If No, Then Move New Number
 RET

THENEG2:
 MOV [VelY], EAX                ; If Yes, Then Move New Number
 NEG [VelY]                     ;   And Negate
 RET
ENDP


;-------------------
; Returns a Random
; Number In AX
; 1 Second Approx 5,000 rand number.(With Overhead)
; 5 Seconds, Approx 30,000 rand numbers.(With Overhead)
;-------------------

RAND PROC
  MOV EAX, [Seed1]              ; Restore Seed Numbers
  MOV EBX, [Seed2]
  MOV ECX, [Seed3]
  MOV EDX, [Seed4]

  ADD EAX, EBX                  ; Perform Weird
  XCHG CL, CH                   ; Operations                
  SBB EDX, EAX                  ; To Insure

  ADC CL, AL
  ADC AH, BL
  ADC EAX, EDX

  ROR EDX, CL                   ; A Good Pseudo
  ROL EAX, CL
  ADC EAX, ECX                  ; Number

  XCHG DL, CH
  XCHG EDX, EBX
  XCHG CH, AL
  XCHG BL, DH

  SBB EAX, ECX
  ADC EAX, EBX

  MOV [Seed1], EAX              ; Save Seed Numbers
  MOV [Seed2], EBX
  MOV [Seed3], ECX
  MOV [Seed4], EDX

  RET                           ; Return
ENDP RAND


;----------------
; Seed Random Numbers
;    Number
; Call Once Before Using RAND
;
;----------------
Seed PROC 

 CALL timeGetTime        ; Get Clock Settings in Milliseconds
 
 MOV EBX, EAX
 ROR EBX, 16
 MOV DX, AX
 MOV CX, BX
 
 MOV [Seed1], EAX        ; Seed 1

 XCHG AL, AH             ; Perform Some Wacky Operations
 SBB AH, AL
 ADC EAX, EAX
 ROR EBX, CL

 MOV [Seed2], EAX        ; Seed 2

 ROR EAX, CL

 MOV [Seed3], EAX        ; Seed 3

 MOV CX, DS              ; Get Data Segment

 ADC ECX, EBX            ; More Wacky Operations
 ADC EAX, EBX
 XCHG AH, BL
 XCHG AL, AH
 ADC AL, AH

 MOV [Seed4], EAX        ; Seed 4
 RET
ENDP Seed



;-=-=-=-=-=-=
; Convert 32 bit number to String
;-=-=-=-=-=-=
NUMBA PROC
     PUSH EDX               ; Save Number
     MOV EBX, 1000000000    ; Start At 1000000000's Place (Max DWORD Base 10)
     PUSH EBX               ; Save The Number Place

     MOV ECX, 10            ; Loop 5 Number Places (1000000000)

     LOOPER:                ; Loop All 5 Number Places
     POP EBX                ; Restore Number Place
     POP EAX                ; Restore Number

     PUSH ECX               ; Save Current Loop Number

     XOR EDX, EDX           ; Clear EDX For DIVISION
     MOV ECX, EAX           ; Save Number and Divide By Number Places

     DIV EBX                ; Divide To Get Only The TOP Digit
			    ; (i.e. 2330/1000 = 2)

     POP EDX                ; Get Current Loop Number 
     PUSH EAX               ; Save Integer Part Of Number/1xxxxx

     ADD AL, 48             ; Add 48 Onto The Low Part (To Make Into Ascii Number)
     MOV [EDI], AL          ; Put Ascii In String

     INC EDI                ; Inc To Next Position in String

     POP EAX                ; Restore Digit
     PUSH EDX               ; Save Current Loop Number

     XOR EDX, EDX           ; Clear EDX For Multiplication
     MUL EBX                ; MULTIPLY By 1xxxx*SingleDigit
			    ; (i.e. 100*3 = 300)
     SUB ECX, EAX           ; Now, Subtract High End Off
			    ; (i.e. 300 - 324 = 24)
     MOV EAX, ECX

     POP ECX                ; Get Current Loop Number
     PUSH EAX               ; Save New Number

     XOR EDX, EDX           ; Clear EDX For Division
     MOV EAX, EBX           ; Get 1xxxx Number

     MOV EBX, 10            ; Divide it By 10 (To Go Down Next Level)
     DIV EBX                ; (i.e. 1000/10 = 100)        

     PUSH EAX               ; Save 1xxxx Number
     LOOP LOOPER            ; If ECX != 0, Loop Again

     POP EAX                ; Clear Stack (Bogus)
     POP EAX                ; & Unused
     RET
ENDP NUMBA


END START



; Copyright 1998 by Toby Opferman
